﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Security;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class PaymentCheck : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //-------------------------------------------
        //  商家端交易查詢傳送程式demo
        //
        //  運作原理：Form POST Method(HTTPS)
        //  流程：Payment.aspx（本程式）->紅陽系統（PaymentCheck.aspx）
        //  參數值說明請參見技術文件
        //-------------------------------------------

        //設定（※請修改）             
        string web = "S1234567890"; //商家代號（超商代收）（可登入商家專區至「服務設定」中查詢24Pay服務的代碼）
        string TranPsw = "test1234"; //訂單編號（可登入商家專區至「密碼修改」處設定，此密碼非後台登入密碼）
        bool isProduction = false; //是否為正式平台（true為正式平台，false為測試平台）

        //準備傳送參數值（請將您的購物網站系統各項數據對應到以下參數，數據來源可能是您的購物網站的資料庫中，請自行撰寫讀取資料庫的方法）
        string MN = "100"; //交易金額(不可有小數點和千位符號。 (新台幣 ))
        string buysafeno = "X000000000000000000"; //訂單編號(紅陽訂單編號: 19 碼)
        string Td = "X00000000000"; //商家訂單編號(此為產生範例，紅陽系統會阻擋同 Td 在同瀏覽器上的未完成交易。)
        string note1 = "備註一"; //備註1（自行應用）
        string note2 = "備註二"; //備註2（自行應用）

        string ChkValue = GetSHA1(web + TranPsw + MN + buysafeno + Td + note1 + note2); //交易檢查碼（SHA1雜湊值並轉成大寫）

        //系統參數（勿修改）
        string paymentURL;
        if (isProduction == true) { paymentURL = "https://www.esafe.com.tw/Service/PaymentCheck.aspx"; }
        else { paymentURL = "https://test.esafe.com.tw/Service/PaymentCheck.aspx"; }

        //查詢訂單
        UTF8Encoding SourceEncoding = new UTF8Encoding(); //使用UTF8編碼
        string data = "web=" + web + "&MN=" + MN + "&buysafeno=" + buysafeno + "&Td=" + Td + "&note1=" + note1 + "&note2=" + note2 + "&ChkValue=" + ChkValue;
        Byte[] EncodingToRequest = SourceEncoding.GetBytes(data);
        string ReturnInfo = ""; //回傳內容
        System.Net.HttpWebRequest HttpWebRequest = ((System.Net.HttpWebRequest)System.Net.WebRequest.Create(paymentURL));
        System.Net.ServicePointManager.ServerCertificateValidationCallback = new System.Net.Security.RemoteCertificateValidationCallback(CheckValidationResult);
        if (isProduction == true) { System.Net.ServicePointManager.SecurityProtocol = System.Net.SecurityProtocolType.Tls11; }
        HttpWebRequest.Method = "POST";                                   //用來連繫網際網路資源的要求方法。預設值為 POST
        HttpWebRequest.KeepAlive = false;                                   //指出是否要與網際網路資源建立持續連線
        HttpWebRequest.ContentType = "application/x-www-form-urlencoded";   //設定 Content-type HTTP 標頭的值
        HttpWebRequest.ContentLength = EncodingToRequest.Length;     //取得或設定 Content-length HTTP 標頭

        try
        {
            System.IO.Stream srmStream = HttpWebRequest.GetRequestStream();        //建立資訊串流
            srmStream.Write(EncodingToRequest, 0, EncodingToRequest.Length);

            System.Net.HttpWebResponse HttpWebResponse = ((System.Net.HttpWebResponse)HttpWebRequest.GetResponse()); //接收回覆的資訊串流
            System.IO.StreamReader StreamReader = new System.IO.StreamReader(HttpWebResponse.GetResponseStream());
            ReturnInfo = StreamReader.ReadToEnd();         //從資訊串流取得資訊
            HttpWebResponse.Close();                //釋放Stream資源
            StreamReader.Close();
            srmStream.Close();
        }
        catch (Exception ex) { processReturn(ex.Message); }

        if (ReturnInfo.IndexOf("##") == -1)  //
        {
            //查無資料
        }


        //商家需確保每次傳送的訂單編號為唯一，若傳送了相同訂單編號至紅陽系統，在查詢時會有多筆資料，此時商家需有能力找出正確的資料
        //（可用returnStr(3)交易時間排序，紅陽系統已使用此時間排序規則排序，第一筆即為最新交易）
        string[] returnStr = ReturnInfo.Split(new string[] { "\r\n" }, StringSplitOptions.None);
        //逐筆處理
        foreach (string element in returnStr)
        {
            string[] elementStr = element.Split(new string[] { "##" }, StringSplitOptions.None);
            ChkValue = GetSHA1(web + TranPsw + buysafeno + MN + returnStr[4]);
            
            //檢查
            if (ChkValue != elementStr[7])
            {
                //交易檢查碼錯誤
            }
            
            if ((buysafeno != "") && (buysafeno != elementStr[1]))
            {
                //紅陽交易編號錯誤
            }
            
            if ((MN!="") && (int.Parse(MN) != int.Parse(elementStr[2])))
            {
                //交易金額錯誤
            }
            
            //若資料檢查無誤，可自行設計更新資料庫訂單狀態
            //以「回覆代碼」判斷交易付款是否成功
            if (elementStr[4] == "00")
            {
                //交易成功
            }
            else 
            {
                //交易失敗
            }
            
        }

    }
    //SHA1雜湊值
    public static string GetSHA1(string value)
    {
        System.Security.Cryptography.SHA1 algorithm = System.Security.Cryptography.SHA1.Create();
        byte[] data = algorithm.ComputeHash(System.Text.Encoding.UTF8.GetBytes(value));
        string sh1 = "";
        for (int i = 0; i < data.Length; i++)
        {
            sh1 += data[i].ToString("x2").ToUpperInvariant();
        }
        return sh1;
    }
    //顯示訊息（避免輸出HTML碼）
    private static bool CheckValidationResult(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors errors)
    {
        return true;
    }  
}