﻿<%@ Page Language="C#" %>

<!DOCTYPE html>

<script runat="server">
    protected void Page_Load(object sender, EventArgs e)
    {
        //設定（※請修改）    
        string web_obj = "S1234567890"; //商家代號（可登入商家專區至「服務設定」中查詢「交貨便」的服務代碼）
        string TranPsw = "test1234"; //訂單編號（可登入商家專區至「密碼修改」處設定，此密碼非後台登入密碼）
        bool isProduction = false; //是否為正式平台（true為正式平台，false為測試平台）

        string CargoFlag_obj = "1"; //超商類別（1：統一超商，2：全家超商）
        string OrderID_obj = "ORD19278223"; //商家訂單編號（或由商家自行運用）
        string ReturnURL_obj = "http(s)://your_path/receive.aspx"; //回傳網址
        string ChkValue_obj = getHashSha256(web_obj + TranPsw + OrderID_obj + CargoFlag_obj + ReturnURL_obj);//檢查碼（SHA256雜湊值）

        //系統參數（勿修改）
        string postURL;
        if (isProduction == true) { postURL = "https://www.esafe.com.tw/Service/Store_Select.aspx"; }
        else { postURL = "https://test.esafe.com.tw/Service/Store_Select.aspx"; }
        
        //設定傳送參數與網址
        Form.Attributes.Add("action", postURL);
        CargoFlag.Value = CargoFlag_obj;
        web.Value = web_obj;
        OrderID.Value = OrderID_obj;
        ReturnURL.Value = ReturnURL_obj;
        ChkValue.Value = ChkValue_obj;
    }

    //SHA256雜湊值
    public static string getHashSha256(string text)
    {
        byte[] bytes = Encoding.UTF8.GetBytes(text);
        System.Security.Cryptography.SHA256Managed hashstring = new System.Security.Cryptography.SHA256Managed();
        byte[] hash = hashstring.ComputeHash(bytes);
        string hashString = string.Empty;
        foreach (byte x in hash)
        {
            hashString += String.Format("{0:x2}", x);
        }
        return hashString;
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
        <div>
            <asp:hiddenfield id="CargoFlag" value="" runat="server"/><!--超商類別-->
            <asp:hiddenfield id="web" value="" runat="server"/><!--商家代碼-->
            <asp:hiddenfield id="OrderID" value="" runat="server"/><!--商家訂單編號-->
            <asp:hiddenfield id="ReturnURL" value="" runat="server"/><!--回傳網址-->
            <asp:hiddenfield id="ChkValue" value="" runat="server"/><!--檢查碼-->
            <input type="submit" name="button" id="button" value="送出" />
        </div>
    </form>
</body>
</html>
