﻿<%@ Page Language="C#" %>
<%@ Import Namespace="System.Security.Cryptography" %>

<!DOCTYPE html>

<script runat="server">
    protected void Page_Load(object sender, EventArgs e)
    {
        //-------------------------------------------
        //  商家端交易授權傳送程式demo（信用卡交易）
        //
        //  運作原理：Form POST Method(HTTPS)
        //  流程：購物網站->send.aspx（本程式）->紅陽系統（Etopm.aspx）->receive.aspx
        //  參數值說明請參見技術文件
        //-------------------------------------------

        //設定（※請修改）        
        string var_web = "S1234567890"; //商家代號（信用卡）（可登入商家專區至「服務設定」中查詢Buysafe服務的代碼）
        string TranPsw = "test1234"; //交易密碼（可登入商家專區至「密碼修改」處設定，此密碼非後台登入密碼）
        bool isProduction = false; //是否為正式平台（true為正式平台，false為測試平台）

        //準備傳送參數值（請將您的購物網站系統各項數據對應到以下參數，數據來源可能是您的購物網站的資料庫中，請自行撰寫讀取資料庫的方法）
        int var_MN = 100; //交易金額(不可有小數點和千位符號。 (新台幣 ))
        string var_OrderInfo = "交易內容"; //交易內容(不可有特殊字元。包含： *'<>[]”)
        string var_Td = DateTime.Now.ToString("yyyyMMddHHmmssf"); //商家訂單編號(此為產生範例，紅陽系統會阻擋同 Td 在同瀏覽器上的未完成交易。)
        string var_sna = "消費者姓名"; //消費者姓名(不可有特殊字元。包含： *'<>[]”)
        string var_sdt = "0987654321"; //消費者電話（空字串""或純數字）
        string var_email = "test@esafe.com.tw"; //消費者Email(空字串或符合 Email格式內容)
        string var_note1 = "備註一"; //備註1（自行應用）
        string var_note2 = "備註二"; //備註2（自行應用）
        string var_Card_Type = "0"; //交易類別(信用卡交易:請帶空字串""或"0"，銀聯卡交易:請帶"1"，Apple Pay、Google Pay:請帶"3")
        string var_Country_Type = ""; //語言類別(中文:請帶空字串""，英文:請帶"EN"，日文:請帶"JIS")
        string var_Term = ""; //分期期數(空字串""或"3"、"6"、"12" 、"18"、"24")
        string var_CargoFlag = "1"; //空白 or 0：不需搭配物流、1：統一超商取貨、2：全家超商取貨、2B：全家大宗寄倉超商取貨、3：OK超商取貨、4：萊爾富超商取貨、E：宅配通
        string var_StoreID = "123456"; //取貨門市店號
        string var_StoreName = "取貨門市"; //取貨門市店名
        string var_BuyerCid = ""; //買方統一編號
        string var_DonationCode = ""; //捐贈碼
        string var_Carrier_ID = ""; //手機條碼
        string var_EDI = "{\"EDI_Name\":\"張小華\",\"EDI_Tel\":\"0912345678\",\"EDI_Address\":\"\",\"EDI_Size\":\"\",\"EDI_Type\":\"\"}"; //物流其他資料
        var_EDI = EncryptData(var_EDI, TranPsw); //加密
        string var_ChkValue = GetSHA1(var_web + TranPsw + var_MN + var_Term); //交易檢查碼（SHA1雜湊值並轉成大寫）
        
        //系統參數（勿修改）
        string paymentURL;
        if (isProduction == true) { paymentURL = "https://www.esafe.com.tw/Service/Etopm.aspx"; }
        else { paymentURL = "https://test.esafe.com.tw/Service/Etopm.aspx"; }

        //產生實際HTML表單值
        //以urlencode()函數避免特殊字碼造成HTML語法錯誤      
        //送出前可檢視原始碼，查看資料是否正確        
        web.Attributes.Add("value", var_web);
        MN.Attributes.Add("value", var_MN.ToString());
        OrderInfo.Attributes.Add("value", System.Web.HttpUtility.UrlEncode(var_OrderInfo));
        Td.Attributes.Add("value", var_Td);
        sna.Attributes.Add("value", System.Web.HttpUtility.UrlEncode(var_sna));
        sdt.Attributes.Add("value", var_sdt);
        email.Attributes.Add("value", var_email);
        note1.Attributes.Add("value", System.Web.HttpUtility.UrlEncode(var_note1));
        note2.Attributes.Add("value", System.Web.HttpUtility.UrlEncode(var_note2));
        Card_Type.Attributes.Add("value", var_Card_Type);
        Country_Type.Attributes.Add("value", var_Country_Type);
        Term.Attributes.Add("value", var_Term);
        CargoFlag.Attributes.Add("value", var_CargoFlag);
        StoreID.Attributes.Add("value", var_StoreID);
        StoreName.Attributes.Add("value", System.Web.HttpUtility.UrlEncode(var_StoreName));
        BuyerCid.Attributes.Add("value", var_BuyerCid);
        DonationCode.Attributes.Add("value", var_DonationCode);
        Carrier_ID.Attributes.Add("value", var_Carrier_ID);
        EDI.Attributes.Add("value", var_EDI);
        ChkValue.Attributes.Add("value", var_ChkValue);

        //設定傳送網址
        Form.Attributes.Add("action", paymentURL);
    }

    //加密函數
    private string EncryptData(string CoyproStr, string EncrKey) {
        byte[] data = Encoding.UTF8.GetBytes(CoyproStr);
        TripleDES tdes = TripleDES.Create();
        tdes.IV = Encoding.UTF8.GetBytes("12345678");
        tdes.Key = Encoding.UTF8.GetBytes("1234567890" + EncrKey.Substring(0,8) + "123456");
        tdes.Mode = CipherMode.ECB;
        tdes.Padding = PaddingMode.Zeros; //填補字串是由設定為零的位元組構成。
        ICryptoTransform ict = tdes.CreateEncryptor(); //建立對稱加密子物件。
        byte[] enc = ict.TransformFinalBlock(data, 0, data.Length);
        return Convert.ToBase64String(enc);
    }

    //SHA1雜湊值
    public static string GetSHA1(string value)
    {
        System.Security.Cryptography.SHA1 algorithm = System.Security.Cryptography.SHA1.Create();
        byte[] data = algorithm.ComputeHash(System.Text.Encoding.UTF8.GetBytes(value));
        string sh1 = "";
        for (int i = 0; i < data.Length; i++)
        {
            sh1 += data[i].ToString("x2").ToUpperInvariant();
        }
        return sh1;
    }
</script>
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
        <div>
            <input runat="server" id="web" type="hidden" />
            <input runat="server" id="MN" type="hidden" />
            <input runat="server" id="OrderInfo" type="hidden" />
            <input runat="server" id="Td" type="hidden" />
            <input runat="server" id="sna" type="hidden" />
            <input runat="server" id="sdt" type="hidden" />
            <input runat="server" id="email" type="hidden" />
            <input runat="server" id="note1" type="hidden" />
            <input runat="server" id="note2" type="hidden" />
            <input runat="server" id="Card_Type" type="hidden" />
            <input runat="server" id="Country_Type" type="hidden" />
            <input runat="server" id="Term" type="hidden" />
            <input runat="server" id="CargoFlag" type="hidden" />
            <input runat="server" id="StoreID" type="hidden" />
            <input runat="server" id="StoreName" type="hidden" />
            <input runat="server" id="BuyerCid" type="hidden" />
            <input runat="server" id="DonationCode" type="hidden" />
            <input runat="server" id="Carrier_ID" type="hidden" />
            <input runat="server" id="EDI" type="hidden" />
            <input runat="server" id="ChkValue" type="hidden" />
            <input type="submit" name="button" id="button" value="送出" />
        </div>

    </form>

</body>
</html>
