﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Security;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class refund : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //-------------------------------------------
        //  商家端信用卡退貨傳送程式demo
        //
        //  運作原理：Form POST Method(HTTPS)
        //  流程：refund.aspx（本程式）->紅陽系統（Hx_CardRefund.aspx）
        //  參數值說明請參見技術文件
        //-------------------------------------------
        //設定（※請修改）             
        string web = "S1234567890"; //商家代號（信用卡）（可登入商家專區至「服務設定」中查詢Buysafe服務代號）
        string TranPsw = "test1234"; //訂單編號（可登入商家專區至「密碼修改」處設定，此密碼非後台登入密碼）
        bool isProduction = false; //是否為正式平台（true為正式平台，false為測試平台）


        //準備傳送參數值（請將您的購物網站系統各項數據對應到以下參數，數據來源可能是您的購物網站的資料庫中，請自行撰寫讀取資料庫的方法）
        string MN = "100"; //退貨金額
        string buysafeno = "S000000000000000000"; //訂單編號(紅陽訂單編號: 19 碼)
        string Td = "00000000000"; //商家訂單編號(紅陽系統會阻擋同 Td 在同瀏覽器上的未完成交易。)
        string RefundMemo = "退貨原因";//退貨原因(不可有特殊字元。包含： *'<>[]”)
        string ChkValue = getHashSha256(web + TranPsw + buysafeno + MN + Td);//交易檢查碼（SHA256雜湊值）

        //系統參數（勿修改）
        string paymentURL;
        if (isProduction == true) { paymentURL = "https://www.esafe.com.tw/Service/Hx_CardRefund.ashx"; }
        else { paymentURL = "https://test.esafe.com.tw/Service/Hx_CardRefund.aspx"; }

        //查詢訂單
        UTF8Encoding SourceEncoding = new UTF8Encoding(); //使用UTF8編碼
        string data = "web=" + web + "&MN=" + MN + "&buysafeno=" + buysafeno + "&Td=" + System.Web.HttpUtility.UrlEncode(Td) + "&RefundMemo=" + System.Web.HttpUtility.UrlEncode(RefundMemo) + "&ChkValue=" + ChkValue;
        Byte[] EncodingToRequest = SourceEncoding.GetBytes(data);
        string ReturnInfo = ""; //回傳內容
        System.Net.HttpWebRequest HttpWebRequest = ((System.Net.HttpWebRequest)System.Net.WebRequest.Create(paymentURL));
        System.Net.ServicePointManager.ServerCertificateValidationCallback = new System.Net.Security.RemoteCertificateValidationCallback(CheckValidationResult);
        if (isProduction == true) { System.Net.ServicePointManager.SecurityProtocol = System.Net.SecurityProtocolType.Tls11; }
        HttpWebRequest.Method = "POST";                                   //用來連繫網際網路資源的要求方法。預設值為 POST
        HttpWebRequest.KeepAlive = false;                                   //指出是否要與網際網路資源建立持續連線
        HttpWebRequest.ContentType = "application/x-www-form-urlencoded";   //設定 Content-type HTTP 標頭的值
        HttpWebRequest.ContentLength = EncodingToRequest.Length;     //取得或設定 Content-length HTTP 標頭

        try
        {
            System.IO.Stream srmStream = HttpWebRequest.GetRequestStream();        //建立資訊串流
            srmStream.Write(EncodingToRequest, 0, EncodingToRequest.Length);

            System.Net.HttpWebResponse HttpWebResponse = ((System.Net.HttpWebResponse)HttpWebRequest.GetResponse()); //接收回覆的資訊串流
            System.IO.StreamReader StreamReader = new System.IO.StreamReader(HttpWebResponse.GetResponseStream());
            ReturnInfo = StreamReader.ReadToEnd();         //從資訊串流取得資訊
            HttpWebResponse.Close();                //釋放Stream資源
            StreamReader.Close();
            srmStream.Close();
        }
        catch (Exception ex) {
            //發生錯誤，原因：ex.Message
        }

        if (ReturnInfo == "E0")
        {
            //退貨申請成功，可自行設計更新資料庫訂單狀態
        }
        else
        {
            //申請失敗，原因：ReturnInfo
        }

    }
    //SHA256雜湊值
    public static string getHashSha256(string text)
    {
        byte[] bytes = Encoding.UTF8.GetBytes(text);
        System.Security.Cryptography.SHA256Managed hashstring = new System.Security.Cryptography.SHA256Managed();
        byte[] hash = hashstring.ComputeHash(bytes);
        string hashString = string.Empty;
        foreach (byte x in hash)
        {
            hashString += String.Format("{0:x2}", x);
        }
        return hashString;
    }
    private static bool CheckValidationResult(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors errors)
    {
        return true;
    }  
}