﻿<%@ Page Language="C#" %>

<!DOCTYPE html>

<script runat="server">
    //-------------------------------------------
    //  商家端交易結果接收程式demo（交貨便交易）
    //
    //  運作原理：Form POST Method(HTTPS)
    //  流程：購物網站->send.aspx->紅陽系統（Etopm.aspx）->receive.aspx（本程式）
    //  參數值說明請參見技術文件
    //-------------------------------------------

    //SHA1雜湊值
    public static string GetSHA1(string value)
    {
        System.Security.Cryptography.SHA1 algorithm = System.Security.Cryptography.SHA1.Create();
        byte[] data = algorithm.ComputeHash(System.Text.Encoding.UTF8.GetBytes(value));
        string sh1 = "";
        for (int i = 0; i < data.Length; i++)
        {
            sh1 += data[i].ToString("x2").ToUpperInvariant();
        }
        return sh1;
    }
    //顯示訊息（避免輸出HTML碼）
    private void processReturn(string errcode)
    {
        Response.Clear();
        Response.Write(errcode);
        Response.End();
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        //設定（※請修改）
        string webno = "S1234567890"; //商家代號（交貨便）（可登入商家專區至「服務設定」中查詢交貨便服務的代碼）
        string TranPsw = "test1234"; //交易密碼（可登入商家專區至「密碼修改」處設定，此密碼非後台登入密碼）

        //接收回傳參數值
        string buysafeno = Request.Form["buysafeno"]; //紅陽交易編號
        string web = Request.Form["web"]; //商家代號
        string Td = Request.Form["Td"]; //商家訂單編號
        string MN = Request.Form["MN"]; //交易金額
        string note1 = HttpUtility.UrlDecode(Request.Form["note1"]); //備註1
        string note2= HttpUtility.UrlDecode(Request.Form["note2"]); //備註2
        string SendType = Request.Form["SendType"]; //傳送方式，1:背景傳送、2:網頁傳送、3:金流模組系統間回傳
        string CargoNo = Request.Form["CargoNo"]; //交貨便代碼
        string StoreName = HttpUtility.UrlDecode(Request.Form["StoreName"]); //取貨門市店名
        string StoreID = Request.Form["StoreID"]; //取貨門市店號
        string ChkValue= Request.Form["ChkValue"]; //交易檢查碼（SHA1雜湊值）
        string StoreType = Request.Form["StoreType"]; //物流狀態代碼
        string StoreMsg = Request.Form["StoreMsg"];  //物流狀態解釋
        
        //檢查商家代號是否正確
        if (webno != web)
        {
            processReturn("商家代號錯誤");
        }
        //檢查交易檢查碼是否正確（SHA1雜湊值）
        else if ((ChkValue == GetSHA1(webno + TranPsw + buysafeno + MN + CargoNo)) && (String.IsNullOrEmpty(StoreType)))
        {
           

            //將接收回傳參數值顯示於畫面上（以下為debug用，正式環境應刪除）
            lb_buysafeno.Text = buysafeno;
            lb_web.Text = web;
            lb_Td.Text = Td;
            lb_MN.Text = MN;
            lb_note1.Text = note1;
            lb_note2.Text = note2;
            lb_SendType.Text = SendType;
            lb_CargoNo.Text = CargoNo;
            lb_StoreID.Text = StoreID;
            lb_StoreName.Text = StoreName;
            lb_ChkValue.Text = ChkValue;

            //交易結果處理
            //可自行設計更新資料庫訂單狀態
            if (CargoNo != "")
            {
                //訂單成功
            }
            else
            {
                //訂單失敗
            }
            //接收「背景回傳確認通知」後需回傳0000，不可包含HTML
            if (SendType == "1") {processReturn("0000");}
        }
        //物流狀態處理
        //可自行設計更新資料庫物流狀態
        else if ((ChkValue == GetSHA1(webno + TranPsw + buysafeno + StoreType)) && (!String.IsNullOrEmpty(StoreType)))
        {
            if (StoreType == "101")
            {
                //抵達取門市
            }
            else if (StoreType == "1010")
            {
                //取貨完成
            }
            else if (StoreType == "1B1B")
            {
                //退貨或退貨取貨完成
            }
        }
        else
        {
            processReturn("交易檢查碼錯誤");
        }
    }  
</script>
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title></title>
    <style type="text/css">
        .table {
            width: 600px;
            margin: auto;
            border: 1px solid #CCCCCC;
        }

        .tdright {
            width: 400px;
            text-align: left;
            border: 1px solid #CCCCCC;
        }

        .tdleft {
            width: 250px;
            text-align: right;
            border: 1px solid #CCCCCC;
        }

        .td1 {
            text-align: center;
        }
    </style>
</head>
<body>
    <form id="form1" runat="server">
        <div>
            <table class="table">
                <tr>
                    <td colspan="2" class="td1">《交貨便(SunShip)回傳接收參數》</td>
                </tr>
                <tr>
                    <td class="tdleft">紅陽訂單編號(buysafeno)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_buysafeno" runat="server" Text=""></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td class="tdleft">商店代號(web)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_web" runat="server" Text=""></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td class="tdleft">商家訂單編號(Td)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_Td" runat="server" Text=""></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td class="tdleft">交易金額(MN)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_MN" runat="server" Text=""></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td class="tdleft">備註1(note1)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_note1" runat="server" Text=""></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td class="tdleft">備註2(note2)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_note2" runat="server" Text=""></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td class="tdleft">傳送方式(SendType)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_SendType" runat="server" Text=""></asp:Label>
                    </td>
                </tr>
                 <tr>
                    <td class="tdleft">交貨便代碼(CargoNo)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_CargoNo" runat="server" Text=""></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td class="tdleft">取貨門市店號(StoreID)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_StoreID" runat="server" Text=""></asp:Label>
                    </td>
                </tr>
                <tr>
                    <td class="tdleft">取貨門市店名(StoreName)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_StoreName" runat="server" Text=""></asp:Label>
                    </td>
                </tr> 
                <tr>
                    <td class="tdleft">交易檢查碼(ChkValue)：</td>
                    <td class="tdright">
                        <asp:Label ID="lb_ChkValue" runat="server" Text=""></asp:Label>
                    </td>
                </tr>            
            </table>
        </div>
    </form>
</body>
</html>
