<?php
//UTF-8編碼
header('Content-Type: text/html; charset=utf-8');

//-------------------------------------------
//  交易查詢程式demo
//
//  運作原理：POST Method(HTTPS)，請啟用curl模組
//  流程：PaymentCheck.php（本程式）
//  參數值說明請參見技術文件
//-------------------------------------------

//設定（※請修改）
$merchantID = 'S1234567890'; //商家代號（信用卡）（可登入商家專區至「服務設定」中查詢欲查詢交易的服務代碼）
$transPassword = 'abcd1234'; //交易密碼（可登入商家專區至「密碼修改」處設定，此密碼非後台登入密碼）
$isProduction = false; //是否為正式平台（true為正式平台，false為測試平台）

//準備傳送參數值（請將您的購物網站系統各項數據對應到以下參數，數據來源可能是您的購物網站的資料庫中，請自行撰寫讀取資料庫的方法）
$web = $merchantID; //商家代號
$MN = "100"; //查詢交易的交易金額
$buysafeno = '2400009912300000019'; //查詢交易的紅陽訂單編號
$Td = 'AD006098101'; //查詢交易的商家訂單編號
$note1 = ''; //查詢交易的備註1
$note2 = ''; //查詢交易的備註2
$ChkValue = getChkValue($web . $transPassword . $MN . $buysafeno . $Td . $note1 . $note2); //交易檢查碼（SHA1雜湊值並轉成大寫）

//系統參數（勿修改）
$paymentCheckURL = ($isProduction) ? 'https://www.esafe.com.tw/Service/PaymentCheck.aspx' : 'https://test.esafe.com.tw/Service/PaymentCheck.aspx'; //傳送網址

$curl = curl_init($paymentCheckURL);
if (!$curl) {
    //傳送失敗
    exit();
}

//查詢訂單
$data = array(
    'web' => $web,
    'MN' => $MN,
    'buysafeno' => $buysafeno,
    'Td' => $Td,
    'note1' => urlencode($note1),
    'note2' => urlencode($note2),
    'ChkValue' => $ChkValue
);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
curl_setopt($curl, CURLOPT_POST, true);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

if (!$str = curl_exec($curl)) {
    //查詢失敗
    exit();
}
curl_close($curl);

if (strpos($str, '##') === false) {
    //查無資料
    exit();
}

//商家需確保每次傳送的訂單編號為唯一，若傳送了相同訂單編號至紅陽系統，在查詢時會有多筆資料，此時商家需有能力找出正確的資料
//（可用$returnStr[3]交易時間排序，紅陽系統已使用此時間排序規則排序，第一筆即為最新交易）
$returnStr = explode("\r\n", $str);
//逐筆處理
foreach ($returnStr as $element) {
    $elementStr = explode('##', $element);
    
    //檢查
    if (($buysafeno != "") && ($buysafeno != $elementStr[1])) {
        //紅陽交易編號錯誤
        exit();
    }
    
    if (($MN!="") && (intval($MN) != intval($elementStr[2]))) {
        //交易金額錯誤
        exit();
    }
    
    $RespCode = $elementStr[4];
    switch ($RespCode) {
        case '00':
            // 交易成功;
            break;
        default:
            // 交易失敗
    }
}

/**
 * 檢查交易檢查碼是否正確（SHA1雜湊值）
 */
function getChkValue($string)
{
    return strtoupper(sha1($string));
}
?>