<?php
//UTF-8編碼
header('Content-Type: text/html; charset=utf-8');

//-------------------------------------------
//  商家端交易授權傳送程式demo（ATM轉帳交易）
//
//  運作原理：Form POST Method(HTTPS)，畫面轉移，不可用背景POST傳送等待回應的方式（例如php的curl函數功能）
//  流程：購物網站->send.php（本程式）->紅陽系統（Etopm.aspx）->receive.php
//  參數值說明請參見技術文件
//-------------------------------------------

//設定（※請修改）
$merchantID = 'S1234567890'; //商家代號（超商代收（條碼））（可登入商家專區至「服務設定」中查詢24payment服務的代碼）
$transPassword = 'abcd1234'; //交易密碼（可登入商家專區至「密碼修改」處設定，此密碼非後台登入密碼）
$isProduction = false; //是否為正式平台（true為正式平台，false為測試平台）

//準備傳送參數值（請將您的購物網站系統各項數據對應到以下參數，數據來源可能是您的購物網站的資料庫中，請自行撰寫讀取資料庫的方法）
$web = $merchantID; //商家代號
$MN = 100; //交易金額，請注意金額必須等於產品單價x數量總和
$OrderInfo = '月餅禮盒：3盒，蛋黃酥：1盒'; //交易內容
$Td = 'AD006098101'; //商家訂單編號
$sna = '王小明'; //消費者姓名
$sdt = '0987654321'; //消費者電話（不可有特殊符號）
$email = 'abc@gmail.com'; //消費者Email
$note1 = ''; //備註1（自行應用）
$note2 = ''; //備註2（自行應用）
$DueDate = date('Ymd', strtotime("+7 days")); //繳款期限，最長 180 天(YYYYMMDD)
$UserNo = 'M123456789'; //用戶編號
$BillDate = date('Ymd'); //列帳日期
$ProductName1 = '網路商品一批'; //產品名稱
$ProductPrice1 = 100; //產品單價
$ProductQuantity1 = 1; //產品數量
$AgencyType = 2; //繳款方式（1：條碼、2：ATM轉帳(虛擬帳號)）
$AgencyBank = 'T'; //ATM 轉帳（虛擬帳號）轉入銀行別（T：合作金庫銀行）
$CargoFlag = ''; //空白 or 0：不需搭配物流、1：統一超商取貨、2：全家超商取貨、2B：全家大宗寄倉超商取貨、3：OK超商取貨、4：萊爾富超商取貨、E：宅配通
$StoreID = ''; //空白(紅陽端提供選擇) or 參考StoreSelect範例程式取得門市資料
$StoreName = ''; //空白(紅陽端提供選擇) or 參考StoreSelect範例程式取得門市資料
$BuyerCid = ''; //買方統一編號
$DonationCode = ''; //捐贈碼
$Carrier_ID = ''; //手機條碼
//物流其他資料
$EDI_array = array('EDI_Name' => '張小華', 'EDI_Tel' => '0912345678', 'EDI_Address' => '', 'EDI_Size' => '', 'EDI_Type' => '');
$EDI = encrypt(json_encode($EDI_array), $transPassword); //加密

$ChkValue = getChkValue($web . $transPassword . $MN); //交易檢查碼（SHA1雜湊值並轉成大寫）

//系統參數（勿修改）
$paymentURL = ($isProduction) ? 'https://www.esafe.com.tw/Service/Etopm.aspx' : 'https://test.esafe.com.tw/Service/Etopm.aspx'; //傳送網址

/**
 * 檢查交易檢查碼是否正確（SHA1雜湊值）
 */
function getChkValue($string)
{
    return strtoupper(sha1($string));
}

/**
 * 加密函數
 */
function encrypt($data, $key) {
	if (strlen($data) % 8) {
		$data = str_pad($data,strlen($data) + 8 - strlen($data) % 8, "\0");
	}

	$encData = openssl_encrypt($data, 'DES-EDE3', '1234567890' . substr($key, 0, 8) . '123456', OPENSSL_NO_PADDING);
	$encData = base64_encode($encData);
	return $encData;
}

//產生實際HTML表單
//以urlencode()函數避免特殊字碼造成HTML語法錯誤
//meta的編碼宣告極為重要，可避免亂碼問題
//送出前可檢視原始碼，查看資料是否正確
?>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<form name="form1" action="<?php echo $paymentURL; ?>" method="POST">
    <input type="hidden" name="web" value="<?php echo $web; ?>">
    <input type="hidden" name="MN" value="<?php echo $MN; ?>">
    <input type="hidden" name="OrderInfo" value="<?php echo urlencode($OrderInfo); ?>">
    <input type="hidden" name="Td" value="<?php echo $Td; ?>">
    <input type="hidden" name="sna" value="<?php echo urlencode($sna); ?>">
    <input type="hidden" name="sdt" value="<?php echo $sdt; ?>">
    <input type="hidden" name="email" value="<?php echo $email; ?>">
    <input type="hidden" name="note1" value="<?php echo urlencode($note1); ?>">
    <input type="hidden" name="note2" value="<?php echo urlencode($note2); ?>">
    <input type="hidden" name="DueDate" value="<?php echo $DueDate; ?>">
    <input type="hidden" name="UserNo" value="<?php echo $UserNo; ?>">
    <input type="hidden" name="BillDate" value="<?php echo $BillDate; ?>">
    <input type="hidden" name="ProductName1" value="<?php echo $ProductName1; ?>">
    <input type="hidden" name="ProductPrice1" value="<?php echo $ProductPrice1; ?>">
    <input type="hidden" name="ProductQuantity1" value="<?php echo $ProductQuantity1; ?>">
    <input type="hidden" name="AgencyType" value="<?php echo $AgencyType; ?>"/>
    <input type="hidden" name="AgencyBank" value="<?php echo $AgencyBank; ?>"/>
    <input type="hidden" name="CargoFlag" value="<?php echo $CargoFlag; ?>">
    <input type="hidden" name="StoreID" value="<?php echo $StoreID; ?>">
    <input type="hidden" name="StoreName" value="<?php echo $StoreName; ?>">
    <input type="hidden" name="BuyerCid" value="<?php echo $BuyerCid; ?>">
    <input type="hidden" name="DonationCode" value="<?php echo $DonationCode; ?>">
    <input type="hidden" name="Carrier_ID" value="<?php echo $Carrier_ID; ?>">
    <input type="hidden" name="EDI" value="<?php echo $EDI; ?>">
    <input type="hidden" name="ChkValue" value="<?php echo $ChkValue; ?>">
    <input type="submit" name="send" value="送出">
</form>
