<?php
//UTF-8編碼
header('Content-Type: text/html; charset=utf-8');

//-------------------------------------------
//  商家端交易授權傳送程式demo（超商代收（代碼）交易）
//
//  運作原理：Form POST Method(HTTPS)
//  交易流程：購物網站->send.php->紅陽系統（Etopm.aspx）->receive.php（本程式）
//  付款流程：消費者付款完成->paid.php
//  參數值說明請參見技術文件
//-------------------------------------------

//設定（※請修改）
$merchantID = 'S1234567890'; //商家代號（超商代收（代碼））（可登入商家專區至「服務設定」中查詢paycode服務的代碼）
$transPassword = 'abcd1234'; //交易密碼（可登入商家專區至「密碼修改」處設定，此密碼非後台登入密碼）

//回傳參數值
$buysafeno = getPostData('buysafeno'); //紅陽交易編號
$web = getPostData('web'); //商家代號
if ($merchantID != $web) {
    exit('商家代號錯誤');
}
$UserNo = getPostData('UserNo'); //用戶編號
$Td = getPostData('Td'); //商家訂單編號
$MN = getPostData('MN'); //交易金額
$note1 = urldecode(getPostData('note1')); //備註1
$note2 = urldecode(getPostData('note2')); //備註2
$SendType = getPostData('SendType'); //傳送方式，1:背景傳送、2:網頁傳送、3:金流模組系統間回傳
$paycode = getPostData('paycode'); //繳款代碼
$PayType = getPostData('PayType'); //可繳款超商
$StoreType = getPostData('StoreType'); //物流狀態代碼
$StoreMsg = urldecode(getPostData('StoreMsg')); //物流狀態解釋
$ChkValue = getPostData('ChkValue'); //交易檢查碼（SHA1雜湊值）

//自行設計更新資料庫訂單狀態
if (!empty($StoreType) && $ChkValue == getChkValue($web . $transPassword . $buysafeno . $StoreType)) {
    //物流狀態回傳
    switch ($StoreType) {
        case '101':
            //表示貨抵達取貨門市
            break;
        case '1010':
            //表示取貨完成
            break;
        case '1B1B':
            //表示欲退貨或退貨取貨完成
            break;
    }
    exit;
} elseif (!empty($paycode) && $ChkValue == getChkValue($web . $transPassword . $buysafeno . $MN . $paycode)) {
    //交易結果回傳
} else {
    exit('交易檢查碼錯誤');
}

//顯示回傳的參數（以下為debug用，正式環境應刪除）
echo '<br>buysafeno=' . $buysafeno; //紅陽交易編號
echo '<br>web=' . $web; //商家代號
echo '<br>UserNo=' . $UserNo; //用戶編號
echo '<br>Td=' . $Td; //商家訂單編號
echo '<br>MN=' . $MN; //交易金額
echo '<br>note1=' . $note1; //備註1
echo '<br>note2=' . $note2; //備註2
echo '<br>SendType=' . $SendType; //傳送方式，1:背景傳送、2:網頁傳送、3:金流模組系統間回傳
echo '<br>paycode=' . $paycode; //繳款代碼
echo '<br>PayType=' . $PayType; //可繳款超商
echo '<br>StoreType=' . $StoreType; //物流狀態代碼
echo '<br>StoreMsg=' . $StoreMsg; //物流狀態解釋
echo '<br>ChkValue=' . $ChkValue; //交易檢查碼（SHA1雜湊值）
//（以上為debug用，正式環境應刪除）

function getPostData($key)
{
    return array_key_exists($key, $_POST) ? $_POST[$key] : '';
}

/**
 * 檢查交易檢查碼是否正確（SHA1雜湊值）
 */
function getChkValue($string)
{
    return strtoupper(sha1($string));
}
?>