<?php
//UTF-8編碼
header('Content-Type: text/html; charset=utf-8');

//-------------------------------------------
//  信用卡交易退貨程式demo
//
//  運作原理：POST Method(HTTPS)，請啟用curl模組
//  流程：refund.php（本程式）
//  參數值說明請參見技術文件
//  進行連線IP控管，請提出申請
//-------------------------------------------

//設定（※請修改）
$merchantID = 'S1234567890'; //商家代號（信用卡）（可登入商家專區至「服務設定」中查詢Buysafe服務代號）
$transPassword = 'abcd1234'; //交易密碼（可登入商家專區至「密碼修改」處設定，此密碼非後台登入密碼）
$isProduction = false; //是否為正式平台（true為正式平台，false為測試平台）

//準備傳送參數值（請將您的購物網站系統各項數據對應到以下參數，數據來源可能是您的購物網站的資料庫中，請自行撰寫讀取資料庫的方法）
$web = $merchantID; //商家代號
$MN = "100"; //退貨交易的交易金額
$buysafeno = '2400009912300000019'; //退貨交易的紅陽訂單編號
$Td = 'AD006098101'; //退貨交易的商家訂單編號
$RefundMemo = ''; //退貨原因;
$ChkValue = getChkValue($web . $transPassword . $buysafeno . $MN . $Td); //交易檢查碼（SHA256雜湊值）

//系統參數（勿修改）
$refundURL = ($isProduction) ? 'https://www.esafe.com.tw/Service/Hx_CardRefund.ashx' : 'https://test.esafe.com.tw/Service/Hx_CardRefund.ashx'; //傳送網址

$curl = curl_init($refundURL);
if (!$curl) {
    //傳送失敗
    exit();
}

//訂單退貨
$data = array(
    'web' => $web,
    'MN' => $MN,
    'buysafeno' => $buysafeno,
    'Td' => $Td,
    'RefundMemo' => urlencode($RefundMemo),
    'ChkValue' => $ChkValue
);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
curl_setopt($curl, CURLOPT_POST, true);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

if (!$str = curl_exec($curl)) {
    //查詢失敗
    exit();
}
curl_close($curl);

if ($str == 'E0') {
    // 退貨成功
}
else {
    // 退貨失敗
    // '失敗原因: ' . $str
}

/**
 * 檢查交易檢查碼是否正確（SHA256雜湊值）
 */
function getChkValue($string)
{
    return hash('sha256', $string);
}
?>
